---
layout: blog
title: Transition to Colemak keyboard layout
segments:
  - blog
  - featured
published: true
date: 2020-05-11T05:38:18.797Z
tags:
  - News
  - Keyboard
  - Colemak
notes: No its not
---

So it has been 3 months since I've made a full transition to only writing on **Colemak keyboard layout**. Now that I am in the middle of the adaptation period is time to sum up what was causing the most problems and what went smoothly.

## What is Colemak keyboard layout

Lazy explanation would be that it is something between _QWERTY_ and _Dvorak_. It keeps the most used shortcuts unchanged and moves the keys that are most frequently used to the middle.

![Colemak keyboard layout preview](https://colemak.com/wiki/images/6/6c/Colemak2.png 'Colemak keyboard layout preview')

At the time of writing this it is the **3rd most used keyboard layout** after those 2 mentioned above.

To get to know _Colemak_ better I'd visit the [official website](https://colemak.com/).

In last article you might get sense of how I got passional for keyboards and it was a gateway for how can I improve my typing experience even more. I had no idea that there was something like _Colemak_ before that. I knew that there is _Dvorak_ but also knew that it is completely different and if I were to learn something new I had to see an easier path. Somewhere on the _YouTube_ I saw few videos and presentations where there were comparisons between layouts and the typical _"Why are we even using QWERTY in 21st century."_ And I couldn't agree more. It is never too late to learn something but I start to regret I haven't done that much sooner.

The best argument to choose _Colemak_ instead of _Dvorak_ was that the most used and sometimes **destructive keyboard shortcuts are kept at the same spot**. So keys like `Q` `W` `A` `Z` `X` `C` `V` are not moved and will still be accessible used with `Ctrl` key. I did have a little problem with these keys anyway as I learned to use all 10 fingers as I was learning _Colemak_. According to _Colemak_ website _"Only 2 keys move between hands"_. Which means that other keys moved only a little.

## How I've learned it

The best way to learn it is to not get frustrated. So don't set high expectations on yourself. I've decided to **practice** each evening for at least 20 - 30 minutes. I started with the home row practice on https://thetypingcat.com/. I'd go from using only 4 keys to whole row by adding 2 keys each time until I've got to 30 words per second.

I've set _Colemak_ as the primary keyboard layout in GNOME which made all shortcuts to only work as I was on _Colemak_ even if I were using _QWERTY_ while I was working. That turned up to be a great start because my brain thinks of shortcuts not by its key but what it usually does. The first shortcut that caused me pain was `Ctrl-S` even thou it only moved one key to the right. I am used to save my files manually so I press this combination a lot. Fortunately `Ctrl-R` does nothing in my _VS Code_ so nothing bad happens when I miss the save. I've lasted for 2 weeks and then I had a comfortable time just being on this weird setup where I had different shortcuts but still familiar keyboard until **[I've built myself a keyboard](https://michalvanko.dev/blog/2020-04-10-custom-redox-keyboard-assembly)** and decided to only type with _Colemak_ on it. So I did it. I've known only home row and some other shortcuts (`Ctrl-P` to open file, `Ctrl-F` to find). And without any practice of other rows I've **jumped into the water** and started to write on keyboard layout with much difficulties but I have to say it is the best way to learn it as you just have to learn what key does what.

For the first week I had a browser tab opened with the keyboard layout so I look up a key and find it that way rather than try out every key. As Sean _"Day 9"_ Plott says: _"You don't click the building in the menu. You find the shortcut and press it anyway so you learn it along the way."_ As he is teaching how to play _StarCraft_. Inspired by this, I don't have to have the keys printed out on the keyboard. I have to **memorize their position** by using them.

You may ask how was I able to work when I was barely able to write? Well as a programmer I don't write that much code. Most of the time the programming consist of reading someone elses code and thinking how to implement certain feature. The writing part is the smallest one really. Most of the writing is done in between the programmers themselves. Yeah I had much **struggles responding to messages** as I was typing a single sentence for whole minute. This frustrated me but I was progressing very quickly.

After few months I've discovered that I can also **setup _Colemak_ on the mobile phone** as well. So I immediately did. Writing on mobile is completely different experience because I tend to miss-click a lot more because of the size of the buttons. And mistakes are harder to auto-correct as it isn't build with the premise of using different layout. The `E` and `I` keys are now next to each other and which causes these mistakes to happen.

![Colemak setup on mobile phone](/images/uploads/colemak_keyboard_mobile.jpg)

## Common struggles

### Shortcuts

The first most common struggle was with shortcuts. Simply my brain is not connecting the letters to the actions but it just remembers that when I press certain combinatation it does that action which I got used to. The most destructive shortcuts are at the same position so I haven't got any serious issues.

### Finding a key

Sounds simple but I often used to just hit the same spot for single key over and over and it just wasn't there. Also quotes are moved on the `P` key position which is hard to find on keyboard as you don't expect a non letter key over there. But it turned out to be a great change.

### Passwords

Another one that your brain don't even think of how it types out, it just does. Well all passwords automatically changed for me so I had to le-learn to write them differently.

## Current state

At this point I am comfortable using _Colemak_ layout without any reoccurring struggles. The typing speed is not even close to what it used to be but that doesn't matter that much. I do a lot of mistakes so the `Backspace` button is used more often. That was the first thing that I got used to actually. The **`CapsLock` button being transformed into `Backspace`** is great idea. I haven't used `CapsLock` ever.

I've started to struggle to type on _QWERTY_ layout instead. Every time I have to type with it I have to look at the keyboard and only type with 4 fingers which is pretty ugly. I'm also used to tap `CapsLock` whenever I do mistake which happens a lot.

In overall I am very happy with the switch. It's not only that I learned typing with all 10 fingers but the layout is much more comfortable as well.
